use std::collections::{BTreeMap, HashMap};
use cdbc::database::Database;
use cdbc_pg::{Postgres, PgPool, PgRow};
use cdbc::column::Column;
use cdbc::decode::Decode;
use cdbc::executor::Executor;
use cdbc::io::chan_stream::{ChanStream, Stream, TryStream};
use cdbc::query::Query;
use cdbc::row::Row;

fn main() -> cdbc::Result<()> {
    let pool = PgPool::connect("postgres://postgres:123456@localhost:5432/postgres")?;
    let mut conn = pool.acquire()?;
    loop {
        let mut data: ChanStream<PgRow> = conn.fetch("select * from biz_activity;");
        data.try_for_each(|item| {
            let mut m = BTreeMap::new();
            for column in item.columns() {
                let v = item.try_get_raw(column.name())?;
                let r: Option<String> = Decode::<'_, Postgres>::decode(v)?;
                m.insert(column.name().to_string(), r);
            }
            println!("{:?}", m);
            drop(m);
            Ok(())
        })?;
    }
}